#!/usr/bin/perl -w

######################################################
#
# PROGRAM       : cycle.pl
# USE           : cycle lights uhidled
# AUTHOR        : aleph
# DATE          : 23.03.09
#
# NOTES         : 
#
#####################################################


use strict;
use Getopt::Long;

my ($PROG)        = ($0 =~ /\/*([^\/]+$)/);
my $debug;

my $pacdrive = 0;
my $controller = 1;

sub help {
        print "\n";
        print " $PROG: cycle through 16 LED`s\n";
        print "\n";
        print " $PROG\n";
        print "\n";
        print "   -d 		debug mode.\n";
        print "   -h 		help mode.\n";
        print "   -c [1-8]	controller\n";
        print "   -p 		pacdrive mode\n";
        
        print "\n";
        exit (1);
}

GetOptions( "help" 		=> \&help, "debug" => \$debug,
	"p|pacdrive"		=> \$pacdrive,
	"c|controller=i"	=> \$controller,
	) or help();

my $val = 1;

while(1){
	printf( "0x%04x\n",int($val));
	my $cmd = sprintf("uhidled -c %d %s -x %x", $controller, ($pacdrive ? "-p ":""), $val );
	system($cmd);
	sleep(1);
	if( $val == 1 << 16 ){
		$val = 1;
	} else {
		$val <<= 1
	}
	
}


exit 0;

#----------------------------------------------------------------

